#include "hmbdc/Copyright.hpp"
#pragma once

namespace hmbdc {
template <char const NAME[], typename T>
struct Typed {
	Typed(){}
	explicit Typed(T v)
	: v_(v){}

	explicit operator T() {
		return v_;
	}

	bool operator <  (Typed t) const { return v_ <  t.v_;}
	bool operator >  (Typed t) const { return v_ >  t.v_;}
	bool operator <= (Typed t) const { return v_ <= t.v_;}
	bool operator >= (Typed t) const { return v_ >= t.v_;}
	bool operator == (Typed t) const { return v_ == t.v_;}

	Typed operator+(Typed t) const {return Typed(v_ + t.v_);}
	Typed operator-(Typed t) const {return Typed(v_ - t.v_);}
	Typed operator*(Typed t) const {return Typed(v_ * t.v_);}
	Typed operator/(Typed t) const {return Typed(v_ / t.v_);}

	Typed& operator+=(Typed t) {v_ += t.v_; return *this;}
	Typed& operator-=(Typed t) {v_ -= t.v_; return *this;}
	Typed& operator*=(Typed t) {v_ *= t.v_; return *this;}
	Typed& operator/=(Typed t) {v_ /= t.v_; return *this;}

private:
	T v_;
};

