#include "hmbdc/Copyright.hpp"
#pragma once

#include "hmbdc/app/Message.hpp"

namespace hmbdc { namespace app {

namespace messagehandler_detail {
struct no_more{};

template <typename CcClient, typename Message>
struct dispatcher {
    bool operator()(CcClient* p, MessageHead& m) {
        if (m.typeTag == Message::typeTag) {
            p->handleMessageCb(m.get<Message>());
            using Wrap = MessageWrap<Message>;
            auto& wrap = static_cast<Wrap&>(m);
            wrap.~Wrap();
            return true;
        }
        return false;
    }
};

template <typename CcClient>
struct dispatcher<CcClient, JustBytes> {
    bool operator()(CcClient* p, MessageHead& m) {
        if (m.typeTag > 1000) { //only deliver user messages
            auto j = &m.get<uint8_t>();
            p->handleJustBytesCb(m.typeTag, j);
        }
        return false;
    }
};

}

template <typename CcClient, typename ... Messages>
struct MessageHandler {
    static void tryDispatch(CcClient* p, MessageHead& w){
    }
    void handleMessage(MessageHead& w) {
    }
};

template <typename CcClient, typename M, typename ... Messages>
struct MessageHandler<CcClient, M, Messages...> {
    static void tryDispatch(CcClient* p, MessageHead& e) {
        if (!messagehandler_detail::dispatcher<CcClient, M>()(p, e))
            NEH::tryDispatch(p, e);
    }
    void handleMessage(MessageHead& w) {
        tryDispatch(static_cast<CcClient*>(this), w);
    }

    using NEH = MessageHandler<CcClient, Messages ...>;
};

}}