#include "hmbdc/Copyright.hpp"
#pragma once

#include "hmbdc/Exception.hpp"

#include <string>

struct msghdr;
namespace hmbdc { namespace comm { namespace inet {
/**
 * @brief resolve a local ip interface using a mask
 * 
 * @param mask in this format: "192.168.0.1/24" or "192.168.0.101" which is the same as "192.168.0.101/32"
 * when using 192.168.0.1/0
 * @param includeLoopback if it is false, the loopback address is excluded from the result
 * @return a local ip matches the mask if no exception is thrown
 */
std::string getLocalIpMatchMask(std::string const& mask);
std::string getLocalIpThruName(std::string const& name);
std::pair<std::string, uint16_t> getPeerIpPort(int fd);
void extractRelicTo(msghdr& to, msghdr const& from, int sent);
}}}
