#include "hmbdc/Copyright.hpp"
#pragma once

#include <string>
#include <utility>

namespace hmbdc { namespace text { namespace stringtriesetclang_detail {

struct const_iterator {
    const_iterator();
    std::pair<const std::string, bool> const* operator->() const;
    std::pair<const std::string, bool> const& operator*() const;
    const_iterator operator++(int);
    const_iterator& operator++();
    bool operator == (const_iterator const&) const;
    bool operator != (const_iterator const&) const;
    char impl_[8];
};

}

struct StringTrieSetClang {
    using const_iterator = stringtriesetclang_detail::const_iterator;
    StringTrieSetClang();
    ~StringTrieSetClang();
    StringTrieSetClang(StringTrieSetClang const&) = delete;
    StringTrieSetClang& operator = (StringTrieSetClang const&) = delete;

    const_iterator begin() const;
    const_iterator end() const;
    void add(std::string const& s);
    void erase(std::string const& s);
    bool check(char const*b, size_t len) const;
    bool check(std::pair<char const*, char const*> const& str) const;
    size_t size() const;
    void* impl_;
};

}}
